package io.swagger.api;

import groovyx.net.http.*
import static groovyx.net.http.ContentType.*
import static groovyx.net.http.Method.*
import io.swagger.api.ApiUtils

import io.swagger.model.Customer
import io.swagger.model.CustomerWhoHaveNotResponded
import io.swagger.model.Error

import java.util.*;

@Mixin(ApiUtils)
class CustomerApi {
    String basePath = "https://reputationcrm.com/v2"
    String versionPath = "/api/v1"

    def createCustomerAutomatic ( String companyid, String firstname, String lastname, String sendtype, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/createCustomerAutomatic"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (companyid == null) {
            throw new RuntimeException("missing required params companyid")
        }
        // verify required params are set
        if (firstname == null) {
            throw new RuntimeException("missing required params firstname")
        }
        // verify required params are set
        if (lastname == null) {
            throw new RuntimeException("missing required params lastname")
        }
        // verify required params are set
        if (sendtype == null) {
            throw new RuntimeException("missing required params sendtype")
        }

        

        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "POST", "",
                    String.class )
                    
    }
    def createCustomerAutomaticWithDelayReviewRequest ( String companyid, String firstname, String lastname, String sendtype, String delayBeforeFirstReviewRequest, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/createCustomerAutomaticWithDelayReviewRequest"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (companyid == null) {
            throw new RuntimeException("missing required params companyid")
        }
        // verify required params are set
        if (firstname == null) {
            throw new RuntimeException("missing required params firstname")
        }
        // verify required params are set
        if (lastname == null) {
            throw new RuntimeException("missing required params lastname")
        }
        // verify required params are set
        if (sendtype == null) {
            throw new RuntimeException("missing required params sendtype")
        }
        // verify required params are set
        if (delayBeforeFirstReviewRequest == null) {
            throw new RuntimeException("missing required params delayBeforeFirstReviewRequest")
        }

        

        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "POST", "",
                    null )
                    
    }
    def createCustomerImmediateFirstReviewRequest ( String companyid, String firstname, String lastname, String sendtype, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/createCustomerImmediateFirstReviewRequest"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (companyid == null) {
            throw new RuntimeException("missing required params companyid")
        }
        // verify required params are set
        if (firstname == null) {
            throw new RuntimeException("missing required params firstname")
        }
        // verify required params are set
        if (lastname == null) {
            throw new RuntimeException("missing required params lastname")
        }
        // verify required params are set
        if (sendtype == null) {
            throw new RuntimeException("missing required params sendtype")
        }

        

        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "POST", "",
                    null )
                    
    }
    def createCustomerManualScheduleOneReviewRequest ( String companyid, String firstname, String lastname, String sendtype, String emailnumber, String smsnumber, String scheduledate, String scheduletime, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, String notes, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/createCustomerManualScheduleOneReviewRequest"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (companyid == null) {
            throw new RuntimeException("missing required params companyid")
        }
        // verify required params are set
        if (firstname == null) {
            throw new RuntimeException("missing required params firstname")
        }
        // verify required params are set
        if (lastname == null) {
            throw new RuntimeException("missing required params lastname")
        }
        // verify required params are set
        if (sendtype == null) {
            throw new RuntimeException("missing required params sendtype")
        }
        // verify required params are set
        if (emailnumber == null) {
            throw new RuntimeException("missing required params emailnumber")
        }
        // verify required params are set
        if (smsnumber == null) {
            throw new RuntimeException("missing required params smsnumber")
        }
        // verify required params are set
        if (scheduledate == null) {
            throw new RuntimeException("missing required params scheduledate")
        }
        // verify required params are set
        if (scheduletime == null) {
            throw new RuntimeException("missing required params scheduletime")
        }

        

        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "POST", "",
                    null )
                    
    }
    def deleteCustomer ( String customerid, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/deleteCustomer"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (customerid == null) {
            throw new RuntimeException("missing required params customerid")
        }

        

        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "DELETE", "",
                    null )
                    
    }
    def getAllCustomersBycompanyId ( String companyid, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getAllCustomersBycompanyId"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (companyid == null) {
            throw new RuntimeException("missing required params companyid")
        }

        if (!"null".equals(String.valueOf(companyid)))
            queryParams.put("companyid", String.valueOf(companyid))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    Customer.class )
                    
    }
    def getCustomersWhoHaveNotYetSubmittedReview ( String companyid, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getCustomersWhoHaveNotYetSubmittedReview"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (companyid == null) {
            throw new RuntimeException("missing required params companyid")
        }

        if (!"null".equals(String.valueOf(companyid)))
            queryParams.put("companyid", String.valueOf(companyid))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    CustomerWhoHaveNotResponded.class )
                    
    }
    def getSingleCustomer ( String customerid, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getSingleCustomer"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (customerid == null) {
            throw new RuntimeException("missing required params customerid")
        }

        if (!"null".equals(String.valueOf(customerid)))
            queryParams.put("customerid", String.valueOf(customerid))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    Customer.class )
                    
    }
    def updateCustomer ( String customerid, String firstname, String lastname, String notes, String email, String mobile, String address, String zipcode, String city, String state, String country, String language, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/updateCustomer"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (customerid == null) {
            throw new RuntimeException("missing required params customerid")
        }
        // verify required params are set
        if (firstname == null) {
            throw new RuntimeException("missing required params firstname")
        }
        // verify required params are set
        if (lastname == null) {
            throw new RuntimeException("missing required params lastname")
        }
        // verify required params are set
        if (notes == null) {
            throw new RuntimeException("missing required params notes")
        }

        

        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "PUT", "",
                    null )
                    
    }
}
