package io.swagger.api;

import groovyx.net.http.*
import static groovyx.net.http.ContentType.*
import static groovyx.net.http.Method.*
import io.swagger.api.ApiUtils

import io.swagger.model.Error
import io.swagger.model.ReviewSites

import java.util.*;

@Mixin(ApiUtils)
class ReviewSitesApi {
    String basePath = "https://reputationcrm.com/v2"
    String versionPath = "/api/v1"

    def getAllReviewSitesByUserName ( String username, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getAllReviewSitesByUserName"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (username == null) {
            throw new RuntimeException("missing required params username")
        }

        if (!"null".equals(String.valueOf(username)))
            queryParams.put("username", String.valueOf(username))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    ReviewSites.class )
                    
    }
    def getAllReviewSitesBycompanyId ( String companyid, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getAllReviewSitesBycompanyId"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (companyid == null) {
            throw new RuntimeException("missing required params companyid")
        }

        if (!"null".equals(String.valueOf(companyid)))
            queryParams.put("companyid", String.valueOf(companyid))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    ReviewSites.class )
                    
    }
}
