package io.swagger.api;

import groovyx.net.http.*
import static groovyx.net.http.ContentType.*
import static groovyx.net.http.Method.*
import io.swagger.api.ApiUtils

import io.swagger.model.Error
import io.swagger.model.Review

import java.util.*;

@Mixin(ApiUtils)
class ReviewsApi {
    String basePath = "https://reputationcrm.com/v2"
    String versionPath = "/api/v1"

    def getReviewsByCompanyID ( String companyid, String howManyReviews, String lastHowManyDays, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getReviewsByCompanyID"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (companyid == null) {
            throw new RuntimeException("missing required params companyid")
        }
        // verify required params are set
        if (howManyReviews == null) {
            throw new RuntimeException("missing required params howManyReviews")
        }
        // verify required params are set
        if (lastHowManyDays == null) {
            throw new RuntimeException("missing required params lastHowManyDays")
        }

        if (!"null".equals(String.valueOf(companyid)))
            queryParams.put("companyid", String.valueOf(companyid))
if (!"null".equals(String.valueOf(howManyReviews)))
            queryParams.put("howManyReviews", String.valueOf(howManyReviews))
if (!"null".equals(String.valueOf(lastHowManyDays)))
            queryParams.put("lastHowManyDays", String.valueOf(lastHowManyDays))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    Review.class )
                    
    }
    def getReviewsByCompanyIDAndReviewSite ( String companyid, String howManyReviews, String lastHowManyDays, String reviewsSite, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getReviewsByCompanyIDAndReviewSite"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (companyid == null) {
            throw new RuntimeException("missing required params companyid")
        }
        // verify required params are set
        if (howManyReviews == null) {
            throw new RuntimeException("missing required params howManyReviews")
        }
        // verify required params are set
        if (lastHowManyDays == null) {
            throw new RuntimeException("missing required params lastHowManyDays")
        }
        // verify required params are set
        if (reviewsSite == null) {
            throw new RuntimeException("missing required params reviewsSite")
        }

        if (!"null".equals(String.valueOf(companyid)))
            queryParams.put("companyid", String.valueOf(companyid))
if (!"null".equals(String.valueOf(howManyReviews)))
            queryParams.put("howManyReviews", String.valueOf(howManyReviews))
if (!"null".equals(String.valueOf(lastHowManyDays)))
            queryParams.put("lastHowManyDays", String.valueOf(lastHowManyDays))
if (!"null".equals(String.valueOf(reviewsSite)))
            queryParams.put("reviewsSite", String.valueOf(reviewsSite))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    Review.class )
                    
    }
    def getReviewsByCompanyIDRatingAndReviewSite ( String companyid, String howManyReviews, String minimumRatings, String reviewsSite, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getReviewsByCompanyIDRatingAndReviewSite"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (companyid == null) {
            throw new RuntimeException("missing required params companyid")
        }
        // verify required params are set
        if (howManyReviews == null) {
            throw new RuntimeException("missing required params howManyReviews")
        }
        // verify required params are set
        if (minimumRatings == null) {
            throw new RuntimeException("missing required params minimumRatings")
        }
        // verify required params are set
        if (reviewsSite == null) {
            throw new RuntimeException("missing required params reviewsSite")
        }

        if (!"null".equals(String.valueOf(companyid)))
            queryParams.put("companyid", String.valueOf(companyid))
if (!"null".equals(String.valueOf(howManyReviews)))
            queryParams.put("howManyReviews", String.valueOf(howManyReviews))
if (!"null".equals(String.valueOf(minimumRatings)))
            queryParams.put("minimumRatings", String.valueOf(minimumRatings))
if (!"null".equals(String.valueOf(reviewsSite)))
            queryParams.put("reviewsSite", String.valueOf(reviewsSite))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    Review.class )
                    
    }
    def getReviewsByCompanyIdAndRating ( String companyid, String howManyReviews, String lastHowManyDays, String minimumRatings, String maximumRatings, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getReviewsByCompanyIdAndRating"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (companyid == null) {
            throw new RuntimeException("missing required params companyid")
        }
        // verify required params are set
        if (howManyReviews == null) {
            throw new RuntimeException("missing required params howManyReviews")
        }
        // verify required params are set
        if (lastHowManyDays == null) {
            throw new RuntimeException("missing required params lastHowManyDays")
        }
        // verify required params are set
        if (minimumRatings == null) {
            throw new RuntimeException("missing required params minimumRatings")
        }
        // verify required params are set
        if (maximumRatings == null) {
            throw new RuntimeException("missing required params maximumRatings")
        }

        if (!"null".equals(String.valueOf(companyid)))
            queryParams.put("companyid", String.valueOf(companyid))
if (!"null".equals(String.valueOf(howManyReviews)))
            queryParams.put("howManyReviews", String.valueOf(howManyReviews))
if (!"null".equals(String.valueOf(lastHowManyDays)))
            queryParams.put("lastHowManyDays", String.valueOf(lastHowManyDays))
if (!"null".equals(String.valueOf(minimumRatings)))
            queryParams.put("minimumRatings", String.valueOf(minimumRatings))
if (!"null".equals(String.valueOf(maximumRatings)))
            queryParams.put("maximumRatings", String.valueOf(maximumRatings))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    Review.class )
                    
    }
    def getReviewsByUserName ( String username, String howManyReviews, String lastHowManyDays, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getReviewsByUserName"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (username == null) {
            throw new RuntimeException("missing required params username")
        }
        // verify required params are set
        if (howManyReviews == null) {
            throw new RuntimeException("missing required params howManyReviews")
        }
        // verify required params are set
        if (lastHowManyDays == null) {
            throw new RuntimeException("missing required params lastHowManyDays")
        }

        if (!"null".equals(String.valueOf(username)))
            queryParams.put("username", String.valueOf(username))
if (!"null".equals(String.valueOf(howManyReviews)))
            queryParams.put("howManyReviews", String.valueOf(howManyReviews))
if (!"null".equals(String.valueOf(lastHowManyDays)))
            queryParams.put("lastHowManyDays", String.valueOf(lastHowManyDays))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    Review.class )
                    
    }
    def getReviewsByUserNameAndRating ( String username, String howManyReviews, String lastHowManyDays, String minimumRatings, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getReviewsByUserNameAndRating"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (username == null) {
            throw new RuntimeException("missing required params username")
        }
        // verify required params are set
        if (howManyReviews == null) {
            throw new RuntimeException("missing required params howManyReviews")
        }
        // verify required params are set
        if (lastHowManyDays == null) {
            throw new RuntimeException("missing required params lastHowManyDays")
        }
        // verify required params are set
        if (minimumRatings == null) {
            throw new RuntimeException("missing required params minimumRatings")
        }

        if (!"null".equals(String.valueOf(username)))
            queryParams.put("username", String.valueOf(username))
if (!"null".equals(String.valueOf(howManyReviews)))
            queryParams.put("howManyReviews", String.valueOf(howManyReviews))
if (!"null".equals(String.valueOf(lastHowManyDays)))
            queryParams.put("lastHowManyDays", String.valueOf(lastHowManyDays))
if (!"null".equals(String.valueOf(minimumRatings)))
            queryParams.put("minimumRatings", String.valueOf(minimumRatings))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    Review.class )
                    
    }
    def getReviewsByUserNameAndReviewSite ( String username, String howManyReviews, String lastHowManyDays, String reviewsSite, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getReviewsByUserNameAndReviewSite"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (username == null) {
            throw new RuntimeException("missing required params username")
        }
        // verify required params are set
        if (howManyReviews == null) {
            throw new RuntimeException("missing required params howManyReviews")
        }
        // verify required params are set
        if (lastHowManyDays == null) {
            throw new RuntimeException("missing required params lastHowManyDays")
        }
        // verify required params are set
        if (reviewsSite == null) {
            throw new RuntimeException("missing required params reviewsSite")
        }

        if (!"null".equals(String.valueOf(username)))
            queryParams.put("username", String.valueOf(username))
if (!"null".equals(String.valueOf(howManyReviews)))
            queryParams.put("howManyReviews", String.valueOf(howManyReviews))
if (!"null".equals(String.valueOf(lastHowManyDays)))
            queryParams.put("lastHowManyDays", String.valueOf(lastHowManyDays))
if (!"null".equals(String.valueOf(reviewsSite)))
            queryParams.put("reviewsSite", String.valueOf(reviewsSite))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    Review.class )
                    
    }
    def getReviewsByUserNameRatingAndReviewSite ( String username, String howManyReviews, String minimumRatings, String reviewsSite, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getReviewsByUserNameRatingAndReviewSite"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (username == null) {
            throw new RuntimeException("missing required params username")
        }
        // verify required params are set
        if (howManyReviews == null) {
            throw new RuntimeException("missing required params howManyReviews")
        }
        // verify required params are set
        if (minimumRatings == null) {
            throw new RuntimeException("missing required params minimumRatings")
        }
        // verify required params are set
        if (reviewsSite == null) {
            throw new RuntimeException("missing required params reviewsSite")
        }

        if (!"null".equals(String.valueOf(username)))
            queryParams.put("username", String.valueOf(username))
if (!"null".equals(String.valueOf(howManyReviews)))
            queryParams.put("howManyReviews", String.valueOf(howManyReviews))
if (!"null".equals(String.valueOf(minimumRatings)))
            queryParams.put("minimumRatings", String.valueOf(minimumRatings))
if (!"null".equals(String.valueOf(reviewsSite)))
            queryParams.put("reviewsSite", String.valueOf(reviewsSite))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    Review.class )
                    
    }
    def postCommentOnReview ( String reviewid, String commenttext, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/postCommentOnReview"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (reviewid == null) {
            throw new RuntimeException("missing required params reviewid")
        }
        // verify required params are set
        if (commenttext == null) {
            throw new RuntimeException("missing required params commenttext")
        }

        

        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "POST", "",
                    null )
                    
    }
}
