package io.swagger.api;

import groovyx.net.http.*
import static groovyx.net.http.ContentType.*
import static groovyx.net.http.Method.*
import io.swagger.api.ApiUtils

import io.swagger.model.Error
import io.swagger.model.OverallCompanyRating
import io.swagger.model.OverallRatingAndReviewCount
import io.swagger.model.ReviewSitesRating
import io.swagger.model.ReviewSitesReputationChange
import io.swagger.model.ReviewSitesReviewCount

import java.util.*;

@Mixin(ApiUtils)
class ReviewsStatsApi {
    String basePath = "https://reputationcrm.com/v2"
    String versionPath = "/api/v1"

    def getNumberOfReviewsPostedInLastDaysByCompanyId ( String companyid, String lastHowManyDays, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getNumberOfReviewsPostedInLastDaysByCompanyId"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (companyid == null) {
            throw new RuntimeException("missing required params companyid")
        }
        // verify required params are set
        if (lastHowManyDays == null) {
            throw new RuntimeException("missing required params lastHowManyDays")
        }

        if (!"null".equals(String.valueOf(companyid)))
            queryParams.put("companyid", String.valueOf(companyid))
if (!"null".equals(String.valueOf(lastHowManyDays)))
            queryParams.put("lastHowManyDays", String.valueOf(lastHowManyDays))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    ReviewSitesReviewCount.class )
                    
    }
    def getNumberOfReviewsRequiredToAchieve5StarByCompanyId ( String companyid, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getNumberOfReviewsRequiredToAchieve5StarByCompanyId"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (companyid == null) {
            throw new RuntimeException("missing required params companyid")
        }

        if (!"null".equals(String.valueOf(companyid)))
            queryParams.put("companyid", String.valueOf(companyid))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    ReviewSitesReviewCount.class )
                    
    }
    def getOverallRatingAndReviewCountForPlatformReviewsByCompanyId ( String companyid, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getOverallRatingAndReviewCountForPlatformReviewsByCompanyId"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (companyid == null) {
            throw new RuntimeException("missing required params companyid")
        }

        if (!"null".equals(String.valueOf(companyid)))
            queryParams.put("companyid", String.valueOf(companyid))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    OverallRatingAndReviewCount.class )
                    
    }
    def getOverallRatingForEachReviewSiteByCompanyId ( String companyid, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getOverallRatingForEachReviewSiteByCompanyId"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (companyid == null) {
            throw new RuntimeException("missing required params companyid")
        }

        if (!"null".equals(String.valueOf(companyid)))
            queryParams.put("companyid", String.valueOf(companyid))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    ReviewSitesRating.class )
                    
    }
    def getOverallRatingOfCompanyByCompanyId ( String companyid, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getOverallRatingOfCompanyByCompanyId"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (companyid == null) {
            throw new RuntimeException("missing required params companyid")
        }

        if (!"null".equals(String.valueOf(companyid)))
            queryParams.put("companyid", String.valueOf(companyid))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    OverallCompanyRating.class )
                    
    }
    def getOverallReputationChangeOfAllReviewSitesByCompanyId ( String companyid, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getOverallReputationChangeOfAllReviewSitesByCompanyId"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (companyid == null) {
            throw new RuntimeException("missing required params companyid")
        }

        if (!"null".equals(String.valueOf(companyid)))
            queryParams.put("companyid", String.valueOf(companyid))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    ReviewSitesReputationChange.class )
                    
    }
    def getTotalReviewsReceivedForEachReviewSiteByCompanyId ( String companyid, Closure onSuccess, Closure onFailure)  {
        // create path and map path parameters (TODO)
        String resourcePath = "/getTotalReviewsReceivedForEachReviewSiteByCompanyId"

        // query params
        def queryParams = [:]
        def headerParams = [:]
    
        // verify required params are set
        if (companyid == null) {
            throw new RuntimeException("missing required params companyid")
        }

        if (!"null".equals(String.valueOf(companyid)))
            queryParams.put("companyid", String.valueOf(companyid))


        // Also still TODO: form params, body param

        invokeApi(onSuccess, onFailure, basePath, versionPath, resourcePath, queryParams, headerParams,
                    "GET", "array",
                    ReviewSitesReviewCount.class )
                    
    }
}
